#include "PSoCAPI.h"
#include "print.h"
#include "cmd.h"
#include "cstdef.h"
#include "cstdio.h"
#include "ctype.h"

#define	RO_1	0x90
#define	RI_3	0xf0
extern unsigned char secbuf[];


#define	MAX_RES		5
WORD crcdat;
WORD wcount,wi,wj,wbufpos;
BYTE rcount;
BYTE mmc_cmd[6];
BYTE mmc_res[MAX_RES];
BYTE mmc_sdtoken;	// X^[gf[^ubNg[N
BYTE mmc_crc[2];	// CRCf[^iMlj
BYTE mmc_dres;		// f[^X|X
BYTE mmc_rwflag;
WORD cal_crc;

BYTE verbose_mode = 1;

void CRC16_1_INPUTSEL(unsigned char c)
{
	CRC16_1_INPUT_LSB_REG = (CRC16_1_INPUT_LSB_REG & 0x0f) | c;
}

void spim_wait_done()
{
	while(!(SPIM_1_bReadStatus() & SPIM_1_SPIM_SPI_COMPLETE))
		;
}

void spim_tx(unsigned char dat)
{
	SPIM_1_SendTxData(dat);
	spim_wait_done();
}

unsigned char spim_rx()
{
	unsigned char rxdat;
	spim_tx(0xff);
	while(!(SPIM_1_bReadStatus() & SPIM_1_SPIM_RX_BUFFER_FULL))
		;
	return(SPIM_1_bReadRxData());
}


void exec_dummyclk()
{
	unsigned char c;
	PRT2DR &= ~0x10;		// CS'H'̂܂܃Q[gJ
	for (c=0; c<10; c++)		// 80Clock(dl̗v72Clockj
		spim_tx(0xff);
	PRT2DR |= 0x10;			// Q[gĂ
}


//
// R}hM
// mmc_cmd[]ɓĂ5oCg̃R}h+{CRC7+'1'}𑗂
// obt@Q[gCSȂǂ͎OɃAT[gĂ
// mmc_cmd[5]ɂ͑CRCf[^Ă
//
void tx_cmd()
{
	unsigned char c;
	CRC16_1_WriteSeed(0);	// l[iKiłȂĂ邩dȂj
	CRC16_1_WritePolynomial(0x0044);		// 1000 1000 0001 0000  // 1000100 x^7+x^3+1
	CRC16_1_INPUTSEL(RO_1);
	CRC16_1_Start();
	for (c=0; c<5; c++) {
		spim_tx(mmc_cmd[c]);
	}
	crcdat = CRC16_1_wReadCRC() & 0x7f;	// CRC7擾
	crcdat = (crcdat<< 1) | 1;
	mmc_cmd[5] = crcdat;
	spim_tx(crcdat);
	CRC16_1_Stop();
}

//
// X|XM
// 0xffǂݎ̂Ă
// rcountŎw肳ꂽTCYǂmmc_res[]Ɋi[
//
#define	TIMEOUT	100
void rx_res()
{
	unsigned char c,dat;
	if (rcount > MAX_RES)
		rcount = MAX_RES;
	for (c=0; c<TIMEOUT; c++) {
		dat = spim_rx();
		if (dat != 0xff)
			break;
	}
	if (c >= TIMEOUT) {
		cmdsts = E_TIMEOUT;
		return;
	}
	mmc_res[0] = dat;
	for (c=1; c<rcount; c++) {
		mmc_res[c] = spim_rx();
	}
}

//
// f[^M
//
// 0xffȊOǂݎꂽƂ납
// wcountoCgǂ
//
void read_sector()
{
	unsigned char c,dat;
	CRC16_1_WriteSeed(0);
	//----CRC16_1_WritePolynomial(0x0044);		// 1000100 x^7+x^3+1
	CRC16_1_WritePolynomial(0x8810);		// 1000 1000 0001 0000  x^16+x^12+x^5+1
	CRC16_1_INPUTSEL(RI_3);
	c = 0;
	for (c=0; c<TIMEOUT; c++) {
		dat = spim_rx();
		if (dat != 0xff)
		break;
	}
	if (c >= TIMEOUT) {
		cmdsts = E_TIMEOUT;
		return;
	}
	mmc_sdtoken = dat;		// X^[gf[^ubNg[N

	CRC16_1_Start();		// CRCvZJn
	for (wi=0; wi<wcount; wi++) {
		secbuf[wi] = spim_rx();
	}
	cal_crc = CRC16_1_wReadCRC();	// vZłCRC擾
	mmc_crc[0] = spim_rx();		// CRC16tĂ͂
	mmc_crc[1] = spim_rx();
	crcdat = CRC16_1_wReadCRC();	// vZłCRC擾
	CRC16_1_Stop();
}

//
// f[^M
//
// 0xffȊOǂݎꂽƂ납
// wcountoCg
//
void write_sector()
{
	unsigned char c,dat;
	CRC16_1_WriteSeed(0);
	CRC16_1_WritePolynomial(0x8810);		// 1000 1000 0001 0000  x^16+x^12+x^5+1
	CRC16_1_INPUTSEL(RO_1);
	c = 0;
	spim_tx(0xfe);			// X^[gf[^ubNg[N

	CRC16_1_Start();		// CRCvZJn
	for (wi=0; wi<wcount; wi++) {
		spim_tx(secbuf[wi]);
	}
	cal_crc = CRC16_1_wReadCRC();	// vZłCRC擾
	mmc_crc[0] = (cal_crc >> 8) & 0xff;
	mmc_crc[1] = cal_crc & 0xff;
	spim_tx(mmc_crc[0]);
	spim_tx(mmc_crc[1]);
	crcdat = CRC16_1_wReadCRC();	// vZłCRC擾
	CRC16_1_Stop();
	for (c=0; c<TIMEOUT; c++) {	// X|Xf[^擾
		mmc_dres = spim_rx();
		if (mmc_dres != 0xff)
			break;
	}
	if (c >= TIMEOUT) {
		cmdsts = E_TIMEOUT;
		return;
	}
	for (c=0; (c<TIMEOUT)&&(spim_rx() != 0xff); c++)	// fBɂȂ̂҂
		;
	if (c >= TIMEOUT)
		cmdsts = E_TIMEOUT;
}


void get_param()
{
	unsigned char c,dat;
	rcount = get2hex();
	if (cmdsts != E_READY)
		return;
	wcount = get4hex();
	if (cmdsts != E_READY)
		return;
	if (wcount >= SECBUFSIZE)
		wcount = SECBUFSIZE;
	for (c=0; c<5; c++) {
		dat = get2hex();
		if (cmdsts != E_READY)
			break;
		if (c == 0) {
			dat = (dat & 0x3f) | 0x40;
		}
		mmc_cmd[c] = dat;
	}
}

#define	MMC_READ	0
#define	MMC_WRITE	1
void disp_buf()
{
	unsigned char c,dat;
	printf("\nCMD    :-");
	for (c=0; c<6; c++)
		printf("%02X ",mmc_cmd[c]);
	printf("\nRES    :-");
	for (c=0; c< rcount; c++)
		printf("%02X ",mmc_res[c]);
	if (wcount) { 			// f[^ƂL
		printf("\nSDTOKEN:-");
		printf("%02X",mmc_sdtoken);
		printf("\nDAT    :-");
		for (wi=0; wi<wcount; wi+=16) {
			printf("\n");
			wj = wi;
			for (c=0; c<16; c++,wj++) {
				if (wj < wcount)
					printf("%02X ",secbuf[wj]);
				else	printf("   ");
			}
			wj = wi;
			for (c=0; c<16; c++,wj++) {
				dat = secbuf[wj];
				if (wj < wcount) {
					if (isprint(dat))
						printf("%c",dat);
					else	printf(".");
				}
			}
		}
		if (mmc_rwflag == MMC_READ)
			printf("\nMMC CRC:-%02X%02X",mmc_crc[0], mmc_crc[1]);
		printf("\nCAL CRC:-%04X",cal_crc);
		printf("\nSUM CRC:-%04X",crcdat);
	}
	if (mmc_rwflag == MMC_WRITE) {
		printf("\nDAT RES:-%02X",mmc_dres);
	}
}

void exec_mmc(unsigned char rwflag)
{
	unsigned char c;
	if (cmdsts != E_READY)
		return;
	mmc_rwflag = rwflag;

	PRT2DR &= ~0x10;	// ܂Q[gJ
	spim_tx(0xff);		// PLN^EFCg҂
	PRT2DR &= ~0x01;	// CS𗎂ƂĂ
	spim_tx(0xff);		// ZbgAbv^C҂

	tx_cmd();		// 5oCgR}h+CRC𑗂
	rx_res();		// X|XM(X|XCRĈłׂ󂯁j
	if (cmdsts == E_READY) {
		if (wcount) {	// f[^]𔺂
			if (mmc_rwflag == MMC_READ)
				read_sector();
			 else	write_sector();
		}
	}
	PRT2DR |= 0x01;		// CS߂
	PRT2DR |= 0x10;		// Q[g
	if (cmdsts != E_READY)
		return;
	if (!verbose_mode)
		return;
	disp_buf();
}

void exec_command()
{
	unsigned char c,dat;
	get_param();
	if (cmdsts != E_READY)
		return;
	exec_mmc(MMC_READ);
}

void exec_reset()
{
	mmc_cmd[0] = 0x40;
	mmc_cmd[1] = 0x00;
	mmc_cmd[2] = 0x00;
	mmc_cmd[3] = 0x00;
	mmc_cmd[4] = 0x00;
	rcount = 1;
	wcount = 0;
	exec_mmc(MMC_READ);
}

void exec_readychk()
{
	mmc_cmd[0] = 0x41;
	mmc_cmd[1] = 0x00;
	mmc_cmd[2] = 0x00;
	mmc_cmd[3] = 0x00;
	mmc_cmd[4] = 0x00;
	rcount = 1;
	wcount = 0;
	exec_mmc(MMC_READ);
}

void wait_ready()
{
	unsigned char c;
	for (c=0; c<TIMEOUT; c++) {
		exec_readychk();
		if ((mmc_res[0] & 1) == 0)
			break;
	}
	if (c >= TIMEOUT)
		cmdsts = E_TIMEOUT;
}


void exec_readcsd()
{
	exec_dummyclk();
	exec_reset();
	wait_ready();
	mmc_cmd[0] = 0x49;
	mmc_cmd[1] = 0x00;
	mmc_cmd[2] = 0x00;
	mmc_cmd[3] = 0x00;
	mmc_cmd[4] = 0x00;
	rcount = 0x1;
	wcount = 0x10;
	exec_mmc(MMC_READ);
	if (!verbose_mode)	// obt@\͂
		disp_buf();
}

void exec_readcid()
{
	exec_dummyclk();
	exec_reset();
	wait_ready();
	mmc_cmd[0] = 0x4A;
	mmc_cmd[1] = 0x00;
	mmc_cmd[2] = 0x00;
	mmc_cmd[3] = 0x00;
	mmc_cmd[4] = 0x00;
	rcount = 0x1;
	wcount = 0x10;
	exec_mmc(MMC_READ);
	if (!verbose_mode)	// obt@\͂
		disp_buf();
}

void exec_readocr()
{
	exec_dummyclk();
	exec_reset();
	wait_ready();
	mmc_cmd[0] = 0x7A;
	mmc_cmd[1] = 0x00;
	mmc_cmd[2] = 0x00;
	mmc_cmd[3] = 0x00;
	mmc_cmd[4] = 0x00;
	rcount = 0x5;
	wcount = 0;
	exec_mmc(MMC_READ);
	if (!verbose_mode)	// obt@\͂
		disp_buf();
}

extern BYTE use_crc;
void exec_crconoff()
{
	if (use_crc)
		use_crc = 0;
	else	use_crc = 1;
	exec_dummyclk();
	exec_reset();
	wait_ready();
	mmc_cmd[0] = 0x7B;
	mmc_cmd[1] = 0x00;
	mmc_cmd[2] = 0x00;
	mmc_cmd[3] = 0x00;
	mmc_cmd[4] = use_crc;
	rcount = 1;
	wcount = 0;
	exec_mmc(MMC_READ);
}

void exec_sendstatus()
{
	exec_dummyclk();
	exec_reset();
	wait_ready();
	mmc_cmd[0] = 0x4d;
	mmc_cmd[1] = 0x00;
	mmc_cmd[2] = 0x00;
	mmc_cmd[3] = 0x00;
	mmc_cmd[4] = use_crc;
	rcount = 2;
	wcount = 0;
	exec_mmc(MMC_READ);
}

//
// 1ZN^i512oCgj[h
//
void exec_read()
{
	unsigned char c,d,dat;
	exec_dummyclk();
	exec_reset();
	wait_ready();
	if (cmdsts != E_READY)
		return;
	mmc_cmd[0] = 0x58;	// CMD24
	mmc_cmd[0] = 0x51;	// CMD11
	for (c=1; c<5; c++) {	// SoCg擪AhX
		mmc_cmd[c] = get2hex();
		if (cmdsts != E_READY)
			break;
	}
	if (cmdsts != E_READY)
		return;
	rcount = 1;
	wcount = SECSIZE;
	exec_mmc(MMC_READ);
	if (cmdsts != E_READY)
		return;
	if (!verbose_mode)	// obt@\͂
		disp_buf();
}

//
// 1ZN^i512oCgjCg
//
void exec_write()
{
	unsigned char c,d,dat;
	exec_dummyclk();
	exec_reset();
	wait_ready();
	if (cmdsts != E_READY)
		return;
	mmc_cmd[0] = 0x58;	// CMD24
	for (c=1; c<5; c++) {	// SoCg擪AhX
		mmc_cmd[c] = get2hex();
		if (cmdsts != E_READY)
			break;
	}
	if (cmdsts != E_READY)
		return;
	dat = get2hex();
	if (cmdsts != E_READY) {	// f[^w肪ȂANZXAhX[15:8]̃CNgf[^
		cmdsts = E_READY;	// G[ȂEE
		dat = mmc_cmd[3];
		for (wi=0; wi<SECSIZE; wi++)
			secbuf[wi] = dat++;
	} else {			// ȂŒf[^Ŗ߂
		for (wi=0; wi<SECSIZE; wi++)
			secbuf[wi] = dat;
	}
	rcount = 1;
	wcount = SECSIZE;
	exec_mmc(MMC_WRITE);
	if (!verbose_mode)	// obt@\͂
		disp_buf();
}

//
// 1ZN^i512oCgjA/Df[^݂
//
void exec_adwrite()
{
	unsigned char c,d,dat;
	exec_dummyclk();
	exec_reset();
	wait_ready();
	if (cmdsts != E_READY)
		return;
	mmc_cmd[0] = 0x58;	// CMD24
	for (c=1; c<5; c++) {	// SoCg擪AhX
		mmc_cmd[c] = get2hex();
		if (cmdsts != E_READY)
			break;
	}
	if (cmdsts != E_READY)
		return;

	DelSig_1_StartAD();
	for (wi=0; wi<SECSIZE; ) {
		if (DelSig_1_fIsDataAvailable()) {
			secbuf[wi] = (DelSig_1_bGetDataClearFlag() << 2) ^ 0x80;
			wi++;
		}
	}
	DelSig_1_StopAD();
	rcount = 1;
	wcount = SECSIZE;
	exec_mmc(MMC_WRITE);
}

void exec_adread()
{
	unsigned char c;
	DelSig_1_StartAD();
	for (wi=0; wi<SECSIZE; ) {
		if (DelSig_1_fIsDataAvailable()) {
			secbuf[wi] = (DelSig_1_bGetDataClearFlag()<<2) ^ 0x80;
			wi++;
		}
	}
	DelSig_1_StopAD();
	printf("\n");
	for (wi=0; wi<SECSIZE; ) {
		for (c=0; c<16; c++,wi++) {
			printf("%02X ",secbuf[wi]);
		}
		printf("\n");
	}
}


